#include "EntityManager.hpp"
#include "Entity.hpp"

EntityManager* EntityManager::sInstance = NULL;
vector<Entity*> EntityManager::entities;

EntityManager* EntityManager::Instance()
{
	if(!sInstance)
		sInstance = new EntityManager();
	return sInstance;
}

void EntityManager::AddEntity(Entity * e)
{
	entities.push_back(e);
}

// initialize all the entities in the game
void EntityManager::Initialize()
{
	int i = 1000;
	AddEntity(new StaticEntity(D3DXVECTOR3(-4*i,1,0), "Tall_Cupboard_02.X", "FILL_COLOUR.jpg"));
	AddEntity(new StaticEntity(D3DXVECTOR3(-3*i,1,0), "Lower_Cupboard_02.X", "FILL_COLOUR.jpg"));
	AddEntity(new StaticEntity(D3DXVECTOR3(-2*i,1,0), "Sink_Cupboard_02.X", "FILL_COLOUR.jpg"));
	AddEntity(new StaticEntity(D3DXVECTOR3(-1*i,1,0), "Upper_Cupboard_02.X", "FILL_COLOUR.jpg"));
	AddEntity(new StaticEntity(D3DXVECTOR3(0*i,1,0), "Lower_Cupboard_02.X", "FILL_COLOUR.jpg"));
	AddEntity(new StaticEntity(D3DXVECTOR3(1*i,1,0), "Sink_Cupboard_02.X", "FILL_COLOUR.jpg"));
	AddEntity(new StaticEntity(D3DXVECTOR3(2*i,1,0), "Upper_Cupboard_02.X", "FILL_COLOUR.jpg"));
	AddEntity(new StaticEntity(D3DXVECTOR3(3*i,1,0), "Lower_Cupboard_02.X", "FILL_COLOUR.jpg"));
	AddEntity(new StaticEntity(D3DXVECTOR3(4*i,1,0), "Upper_Cupboard_02.X", "FILL_COLOUR.jpg"));
	AddEntity(new StaticEntity(D3DXVECTOR3(5*i,1,0), "Lower_Cupboard_02.X", "FILL_COLOUR.jpg"));
	AddEntity(new StaticEntity(D3DXVECTOR3(6*i,1,0), "Tall_Cupboard_02.X", "FILL_COLOUR.jpg"));
	//AddEntity(new StaticEntity(D3DXVECTOR3(0*i,1,600), "Window_Wall_02.X", "FILL_COLOUR.jpg"));
	AddEntity(new StaticEntity(D3DXVECTOR3(0*i,1,600), "Sky_02.X", "Sky.jpg"));
	AddEntity(new Knife(D3DXVECTOR3(1.6*i,2000,0), "Knife_02.X", "FILL_COLOUR.jpg", 1200));
	AddEntity(new Knife(D3DXVECTOR3(1.8*i,2000,0), "Knife_02.X", "FILL_COLOUR.jpg", 1100));
	AddEntity(new Knife(D3DXVECTOR3(2.0*i,2000,0), "Knife_02.X", "FILL_COLOUR.jpg", 800));
	AddEntity(new Knife(D3DXVECTOR3(2.2*i,2000,0), "Knife_02.X", "FILL_COLOUR.jpg", 700));
	AddEntity(new Knife(D3DXVECTOR3(2.4*i,2000,0), "Knife_02.X", "FILL_COLOUR.jpg", 900));
	AddEntity(new Cheese(D3DXVECTOR3(4.8*i,1800,0), "The_Cheese_02.X", "FILL_COLOUR.jpg"));
	AddEntity(new Cheese(D3DXVECTOR3(4.6*i,2000,0), "The_Cheese_02.X", "FILL_COLOUR.jpg"));

	AddEntity(new Knife(D3DXVECTOR3(3.2*i,2000,0), "Knife_02.X", "FILL_COLOUR.jpg", 1200));
	AddEntity(new Knife(D3DXVECTOR3(3.4*i,2000,0), "Knife_02.X", "FILL_COLOUR.jpg", 1100));
	AddEntity(new Knife(D3DXVECTOR3(3.6*i,2000,0), "Knife_02.X", "FILL_COLOUR.jpg", 800));
	AddEntity(new Knife(D3DXVECTOR3(3.8*i,2000,0), "Knife_02.X", "FILL_COLOUR.jpg", 700));
	AddEntity(new Knife(D3DXVECTOR3(3.9*i,2000,0), "Knife_02.X", "FILL_COLOUR.jpg", 900));
	
	
	
	


}
