#ifndef __PHYSICSMANAGER__
#define __PHYSICSMANAGER__
#include "MiscUtilities.hpp"
#include "EntityManager.hpp"
#include "Sound3DObject.hpp"
#include <btBulletDynamicsCommon.h>
#include "NeheTimer.hpp"

class Entity;
class PhysicsContainer;
class MousePlayer;
class GraphicsManager;

class Jump
{
public:
	Jump();
	bool isJumping;
	void doJump();
	void Update();
	float initial_force_of_jump;
	float rate_of_decrease_per_second;
	float current_force;
	NeheTimer jumpTimer;
};

class PhysicsManager
{
private:
	static PhysicsManager *sInstance;
	static btDiscreteDynamicsWorld* dynamicsWorld;
public:
	static PhysicsManager* Instance();
	static void Initialize();
	static void Update();
	static MousePlayer * player;
	static btDiscreteDynamicsWorld* GetDynamicsWorld();
	static Sound3DObject * fireSound;

};

#endif