#include "Sound3DObject.hpp"

//A reference to fmod manager that all instances can access.
FMODManager *Sound3DObject::fMan = NULL;

void Sound3DObject::Create3DSound
(const char *soundPath, bool isStream, 
 FMOD_MODE createFlags, 
 float xPos, float yPos, float zPos)
{
	fMan->CreateSound
		(soundPath, ourSound, isStream, createFlags);

	ourSound->set3DMinMaxDistance(50.0f, 10000.0f);
	
	fMan->PlayFSound
		(ourSound, ourChannel, true);
	fMan->system->update();
	fMan->PauseChannel(ourChannel);

	SetPosition(xPos, yPos, zPos);

	
	ourVelocity.x = 0.0f;
	ourVelocity.y = 0.0f;
	ourVelocity.z = 0.0f;
	

}

void Sound3DObject::SetPosition
(float xPos, float yPos, float zPos)
{
	ourPosition.x = xPos;
	ourPosition.y = yPos;
	ourPosition.z = zPos; 

	ourChannel->set3DAttributes(&ourPosition, &ourVelocity);
	fMan->system->update();

}