#ifndef __Sound3DObjectH_
#define __Sound3DObjectH_

// Standard Includes
#include <windows.h>
#include <stdio.h>
#include <conio.h>

// FMod Inlcudes
#include "fmod.hpp"
#include "fmod_errors.h"

#include "FMODUtility.hpp"
#include "MiscUtilities.hpp"

class Sound3DObject
{
public:

	void Create3DSound(
		const char *soundPath, bool isStream, FMOD_MODE createFlags,
		float xPos, float yPos, float zPos);
	void SetPosition(float xPos, float yPos, float zPos);
	void SetListenerPosition(float xPos, float yPos, float zPos);

	FMOD_VECTOR ourPosition;
	FMOD_VECTOR ourVelocity;

	FMOD::Sound *ourSound;
	FMOD::Channel *ourChannel;

	static FMODManager *fMan;

};

#endif